#include "moldyn.h"

void moveb (float *kinetic, float vx[], float vy[], float vz[], int natm)
{
   extern float *scrat;
   extern float dt;
   float dt2;
   float *fx = &scrat[FOR1];
   float *fy = &scrat[FOR2];
   float *fz = &scrat[FOR3];
   int i;

   dt2 = dt*0.5;
   *kinetic = 0.0;

	float k = *kinetic;

	#pragma omp parallel for private(i) shared(vx,vy,vz,dt2,fx,fy,fz,natm) reduction(+:k)
	for(i=0;i<natm;i++){
		vx[i] = vx[i] + dt2*fx[i];
		vy[i] = vy[i] + dt2*fy[i];
		vz[i] = vz[i] + dt2*fz[i];
		k += vx[i]*vx[i] + vy[i]*vy[i] + vz[i]*vz[i];
	}

	*kinetic = k;

   *kinetic *= 0.5;
}

