#include <math.h>
#include <stdio.h>

void tidyup ()
{
   extern int nstep, nequil;
   extern float ace, ack, acv, acp, acesq, acksq, acvsq, acpsq;

/* Timing Instrumentation - MJC */
#ifdef TIMING
   extern double ttime, forcestime, movouttime, sumtime, startuptime, itertime, moveatime, movebtime, sumtime, hlooptime;
#endif

   float norm, ave, avk, avv, avp, avt;
   float fle=0.0;
   float flv=0.0;
   float flk=0.0;
   float flp=0.0;
   float flt=0.0;

   norm = (float)(nstep-nequil);
   ave  = ace/norm;
   avk  = ack/norm;
   avv  = acv/norm;
   avp  = acp/norm;

   acesq = (acesq/norm) - ave*ave;
   acksq = (acksq/norm) - avk*avk;
   acvsq = (acvsq/norm) - avv*avv;
   acpsq = (acpsq/norm) - avp*avp;

   if (acesq > 0.0) fle = sqrt((double)acesq);
   if (acksq > 0.0) flk = sqrt((double)acksq);
   if (acvsq > 0.0) flv = sqrt((double)acvsq);
   if (acpsq > 0.0) flp = sqrt((double)acpsq);

   avt = avk/1.5;
   flt = flk/1.5;

/* Timing Instrumentation - MJC */
#ifdef TIMING
   printf ("\n\n Total Time %10.5f", ttime);
   printf ("\n Forces Time %10.5f", forcestime);
   printf ("\n Movout Time %10.5f", movouttime);
   printf ("\n Iterations Time %10.5f", itertime);
   printf ("\n MoveA Time %10.5f", moveatime);
   printf ("\n MoveB Time %10.5f", movebtime);
   printf ("\n Sum Time %10.5f", sumtime);
   printf ("\n Hloop Time %10.5f", hlooptime);
   printf ("\n Startup Time %10.5f\n", startuptime);

#endif
}


